jQuery(function ($) {

    $('.floating_action_button_select_two').select2({
        'width':'100%',
        'height':'500px',
        'dropdownCssClass':'bigdrop',
        placeholder: 'Select an item',
        minimumInputLength: 2,
        ajax: {
            url: 'admin-ajax.php?action=get_all_woo_commerce_products',
            dataType: 'json',
            delay: 250,
            processResults: function (data) {
                return {
                    results: data
                };
            },
            cache: true
        }
    });


    $(document).ready(function () {
        $(".qc_floating_action_button_mode option").each(function () {
            $(this).siblings("[value='" + this.value + "']").remove();
        });

        [].slice.call(document.querySelectorAll('.tabs-qc-fab')).forEach(function (el) {
            new CBPFWTabs(el);
        });
        //Support Quickball on floating_action_button
        if($('#qc_fab_support_quickball').is(':checked')){
            $('#qc_fab_support_quickball_email_contianer').show();
        }else{
            $('#qc_fab_support_quickball_email_contianer').hide();
        }

        $(document).on('change','#qc_fab_support_quickball',function () {
            if($(this).is(':checked')){
                $('#qc_fab_support_quickball_email_contianer').show();
            }else{
                $('#qc_fab_support_quickball_email_contianer').hide();
            }
        })

        //Custom quickball for floating_action_button.
        if($('#qc_fab_custom_quickball').is(':checked')){
            $('#qc_fab_custom_quickball_link_contianer').show();
            $('.qc_fab_custom_quickball_icon_contianer').show();
        }else{
            $('#qc_fab_custom_quickball_link_contianer').hide();
            $('.qc_fab_custom_quickball_icon_contianer').hide();
        }

        $(document).on('change','#qc_fab_custom_quickball',function () {
            if($(this).is(':checked')){
                $('#qc_fab_custom_quickball_link_contianer').show();
                $('.qc_fab_custom_quickball_icon_contianer').show();
            }else{
                $('#qc_fab_custom_quickball_link_contianer').hide();
                $('.qc_fab_custom_quickball_icon_contianer').hide();
            }
        })


        $(".qc_fab_select2_other").select2({width: '100%', height: '500px', dropdownCssClass: "bigdrop"});



        if ($(".floating_action_button_sentence_builder").length) {

            $(".floating_action_button_sentence_builder .repeatable").repeatable({
                addTrigger: ".floating_action_button_sentence_builder .add",
                deleteTrigger: ".floating_action_button_sentence_builder .delete",
                template: "#floating_action_button_sentence_builder",
                startWith: 1,
                onDelete: function () {
                    build_search_phrase();
                }
            });

            $(".floating_action_button_sentence_builder").on("change", ".qc-floating_action_button-filter", function () {
                if ($(this).val() == "price") {
                    $(this).parents(".field-group:eq(0)").find(".price-set").removeClass('qc-floating_action_button-hide');
                    $(this).parents(".field-group:eq(0)").find(".label-set").addClass('qc-floating_action_button-hide');
                } else {
                    $(this).parents(".field-group:eq(0)").find(".price-set").addClass('qc-floating_action_button-hide');
                    $(this).parents(".field-group:eq(0)").find(".label-set").removeClass('qc-floating_action_button-hide');
                }
            });

            $(".floating_action_button_sentence_builder .repeatable").sortable({
                items: "> div.field-group", cursor: "move", stop: function (event, ui) {

                    build_search_phrase();

                }
            });
            $(".floating_action_button_sentence_builder .repeatable");

        }


        // Setup the tips
       /* jQuery(".tips, .help_tip").tipTip({
            attribute: "data-tip",
            fadeIn: 50,
            fadeOut: 50,
            delay: 200,
            defaultPosition: "top"
        });*/

        build_search_phrase();

        $(".floating_action_button_sentence_builder .repeatable").on("keyup", ".field-group .qc-floating_action_button-text", build_search_phrase);
        $(".floating_action_button_sentence_builder .repeatable").on("change", ".field-group .qc-floating_action_button-filter", build_search_phrase);
        $(".floating_action_button_sentence_builder .repeatable").on("keyup", ".field-group .floating_action_button-priceone", build_search_phrase);
        $(".floating_action_button_sentence_builder .repeatable").on("keyup", ".field-group .floating_action_button-pricetwo", build_search_phrase);
        $(".floating_action_button_sentence_builder .repeatable").on("keyup", ".field-group .qc-floating_action_button-label", build_search_phrase);
        $(".shop-floating_action_button-button-text").on("keyup", build_search_phrase);
        //Handling floating_action_button mode.
        var floating_action_buttonMode=$("#qc_floating_action_button_mode").val();
       if(floating_action_buttonMode == 'floating'){
           $("#qc_fab_position_x").val(0);
           $("#position_x_unit").val('px');
           $("#qc_fab_position_x").attr('disabled',true);
           $("#position_x_unit").attr('disabled',true);
       }
        $("#qc_floating_action_button_mode").on('change',function (e) {
            if($(this).val() == 'floating'){
                $("#qc_fab_position_x").val(0);
                $("#position_x_unit").val('px');
                $("#qc_fab_position_x").attr('disabled',true);
                $("#position_x_unit").attr('disabled',true);
            }else{
                $("#qc_fab_position_x").attr('disabled',false);
                $("#position_x_unit").attr('disabled',false);
            }
        })

    });

    function build_search_phrase(){
        var output = "";

        $(".floating_action_button_sentence_builder .repeatable .field-group").each(function () {

            var text = $(this).find(".qc-floating_action_button-text").val();

            if (text != "") {
                output += text + " ";
            }

            var filter = $(this).find(".qc-floating_action_button-filter").val();


            if (filter != "") {

                var priceone = $(this).find(".floating_action_button-priceone").val();
                var pricetwo = $(this).find(".floating_action_button-pricetwo").val();
                var label = $(this).find(".qc-floating_action_button-label").val();

                if (filter == "price") {

                    output += '<span class="phrase-example-filter">' + priceone + '</span> & <span class="phrase-example-filter">' + pricetwo + '</span> ';

                } else {

                    output += '<span class="phrase-example-filter">' + label + "</span> ";

                }

            }

        });

        if (output != "") {
            output = output.substring(0, output.length - 1);

            var button_text = $(".qc_fab-search-button-text").val();

            if (button_text != "") {
                output += '. <span class="phrase-example-button">' + button_text + '</span>';
            } else {
                output += '. <span class="phrase-example-button"></span>';
            }

            $(".search-phrase").html(output);
            $(".search-phrase").show();
            $(".pre-search-phrase").hide();
        } else {
            $(".pre-search-phrase").show();
            $(".search-phrase").hide();
        }

    }

    //Removing item with out ajax loading
    $('.qcld-remove-on-item').on('click',function () {
        if(confirm('Are you sure to delete order notification block?')){
            $(this).parent().parent().remove();
        }
    });
    //Save into hidden field all notification data.
    $('#save-order-notification').on('click',function () {
       var inner_blocks=$('.block-inner'), single;
        var inner_blocks_vals=[];
        $.each(inner_blocks, function(i, obj) {
            single = {
                'product_id': $(obj).find('select').val(),
                'customer_name': $(obj).find('.customer-name').val(),
                'customer_address': $(obj).find('.customer-address').val(),
                'notification_duration': $(obj).find('.notification-duration').val(),
            };

            inner_blocks_vals.push(single);
        });
        $("#artificial-orders-val").val(JSON.stringify(inner_blocks_vals));
        if(inner_blocks_vals.length>0){
            alert('Order Notificaion has been saved');
        }else{
            alert('No Order details');
        }
    });
    //Reset to defualt all options
    $('#qc_fab-reset-options-default').on('click',function () {
        var returnDefualt = confirm("Are you sure you want to reset all options to Default? Resetting Will Delete All Saved Settings, Custom Messages, Languages etc.");
        if (returnDefualt == true) {
            var data = {
                'action': 'qc_fab_delete_all_options_for_uninstall'
            };
            jQuery.post(ajax_object.ajax_url, data, function (response) {
                alert(response);
                window.location.reload();
            });
        }
    });
    //Exclude paages to load floating_action_button
    if($("input[type=radio][name='qc_fab_show_pages']:checked").val()=='off'){
        $('#qc_fab-show-pages-list').show('slow');
    }else{
        $('#qc_fab-show-pages-list').hide('slow');
    }
    //on change.
    $('.qc_fab-show-pages').on('change',function (e) {
        if( $(this).val()=='off'){
            $('#qc_fab-show-pages-list').show('slow');
        }else{
            $('#qc_fab-show-pages-list').hide('slow');
        }
    });
    // floating_action_button Custom Icon
    $('.qc_fab_custom_icon_button').click(function(e) {
        e.preventDefault();
        var image = wp.media({
            title: 'Custom Icon',
            // mutiple: true if you want to upload multiple files at once
            multiple: false
        })
            .open()
            .on('select', function(e){
                // This will return the selected image from the Media Uploader, the result is an object
                var uploaded_image = image.state().get('selection').first();
                var image_url = uploaded_image.toJSON().url;
                // Let's assign the url value to the hidden field value and img src.
                $('#qc_fab_custom_icon_src').attr('src',image_url);
                $('#qc_fab_custom_icon_path').val(image_url);
            });
    });
    // floating_action_button Custom Quickball Icon
    $('.qc_fab_custom_quickball_icon_button').click(function(e) {
        e.preventDefault();
        var image = wp.media({
            title: 'Custom Icon',
            // mutiple: true if you want to upload multiple files at once
            multiple: false
        })
            .open()
            .on('select', function(e){
                // This will return the selected image from the Media Uploader, the result is an object
                var uploaded_image = image.state().get('selection').first();
                var image_url = uploaded_image.toJSON().url;
                // Let's assign the url value to the hidden field value and img src.
                $('#qc_fab_custom_quickball_icon_src').attr('src',image_url);
                $('#qc_fab_custom_quickball_path').val(image_url);
            });
    });


    $(document).on('click','#custom_floating_add_new_button_contianer',function (event) {
    // $("#custom_floating_add_new_button_contianer").on('click',function () {
        // var lastChildVal=$(this).parent().parent().find('.custom_button_add_group').children('#custom_action_button_link_contianer').last().find('.custom_buttons_links').val();
        var lastChildVal=$(this).parent().parent().parent().find('.custom_button_add_group').children().find('.custom_button_action_control').val();
        //alert(lastChildVal);

        var custom_image = plugins_url.pluginsurl + 'custom.png';
        
        //console.log(custom_image);

        var firsBlock='<div class="custom_button_div_containers"><ul class="radio-list">'+
                            '<li>'+
                                '<img id="qc_fab_custom_quickball_icon_srcs" src="'+ custom_image +'" alt="">'+
                                '<input id="qc_fab_custom_quickball_icon_inputs" type="hidden" name="qc_fab_social_icon_url[]" value="'+ custom_image +'" >'+
                                '<span class="qc-opt-dcs-font">Custom Icon</span>'+
                            '</li>'+
                        '</ul>'+
                       
                        '<div class="col-xs-12">'+
                            '<p class="qc-opt-title-font"><strong> Upload  Quickball Custom Icon </strong></p>'+
                            '<div class="cxsc-settings-blocks">'+
                                '<button type="button" class="qc_fab_custom_quickballs_icon_button button">Upload Icon </button>'+
                            '</div>'+
                        '</div>'+
                        '<div class="cxsc-settings-blocks qcld-custom_disabled_quickbox">'+
                            '<input id="disable_qc_fab_custom_quickball" type="checkbox" name="qcld_disable_qc_fab_custom_quickballs[]"'+
                                   'value="enable_qc_fab_custom_quickball" checked >'+
                            '<label for="disable_qc_fab_custom_quickball">Enable custom quickball on Floating Action Button</label>'+
                        '</div>'+
                        '<div class="custom_button_action_control">'+
                               '<select name="qc_fab_social_title[]" id="button_type" class="button_action qcld_social_selects">'+
                                    '<option value="url" selected="selected">Website URL</option>'+
                                    '<option value="phone">Phone number</option>'+
                                    '<option value="mail">E-mail</option>'+
                                    '<option value="facebook">Share on Facebook</option>'+
                                    '<option value="twitter">Share on Twitter</option>'+
                                    '<option value="whatsapp">Share on Whatsapp</option>'+
                                    '<option value="linkedin">Share on Linkedin</option>'+
                                '</select>'+
                                 '<input id="qc_fab_custom_quickball_links" class="form-control custom_buttons_links" type="text" name="qc_fab_social_url[]" value="">'+
                        '</div>'+
                        '<button type="button" class="btn btn-warning btn-sm qc_fab-remove-container pull-right"><i class="fa fa-times" aria-hidden="true"></i></button>'+
                        '</div>';
           // $(".custom_button_add_group .custom_button_action_control").append(firsBlock);
        if(lastChildVal!=""){
            $(".custom_button_add_group .custom_button_div_container").append(firsBlock);
        } else{
            alert('Please fill up last notification message first');
        }

    });

    

    //Remove Support query.
    $(document).on('click','.qc_fab-remove-container',function () {
        if(confirm('Are you sure to delete this field ?')){
            $(this).parent().remove();
        }
    });

    //Remove Support query.
    $(document).on('change','.qcld_social_selects',function (e) {
        //$('#commentselector').change(function(){
        e.preventDefault();

        if( $(this).val()=='phone'){
            var custom_image = plugins_url.pluginsurl + 'social-phone.png';
            var langItems=$(this).parent().find('.custom_buttons_links');
            $( langItems ).attr('type', 'number');
            $( langItems ).attr("required", true);
            $( langItems ).removeAttr('disabled');

        }else if($(this).val()=='mail'){
            var custom_image = plugins_url.pluginsurl + 'social-mail.png';
            var langItems=$(this).parent().find('.custom_buttons_links');
            $( langItems ).attr('type', 'email');
            $( langItems ).attr("required", true);
            $( langItems ).removeAttr('disabled');

        }else if($(this).val()=='facebook'){
            var custom_image = plugins_url.pluginsurl + 'social-facebook.png';
            var langItems=$(this).parent().find('.custom_buttons_links');
            $( langItems ).attr('type', 'url');
            $( langItems ).val("");
            $( langItems ).attr("required", false);
           
        }else if($(this).val()=='twitter'){
            var custom_image = plugins_url.pluginsurl + 'social-twitter.png';
            var langItems=$(this).parent().find('.custom_buttons_links');
            $( langItems ).attr("required", false);
            $( langItems ).val("");
            $( langItems ).attr('type', 'text');

        }else if($(this).val()=='whatsapp'){
            var custom_image = plugins_url.pluginsurl + 'social-whatsapp.png';
            
            var langItems=$(this).parent().find('.custom_buttons_links');
            $( langItems ).attr('type', 'url');
            $( langItems ).val("");
            $( langItems ).attr("required", false);

        }else if($(this).val()=='linkedin'){
            var custom_image = plugins_url.pluginsurl + 'social-linkedin.png';
            
            var langItems=$(this).parent().find('.custom_buttons_links');
            $( langItems ).attr('type', 'url');
            $( langItems ).val("");
            $( langItems ).attr("required", false);

        }else{
            var custom_image = plugins_url.pluginsurl + 'custom.png';  
            var langItems=$(this).parent().find('.custom_buttons_links');
            $( langItems ).attr('type', 'url');
            $( langItems ).val("");
            $( langItems ).attr("required", true);

        }
        
       // console.log(custom_image);

        var img_destination = $(this).parent().parent().find('.radio-list').children().find('#qc_fab_custom_quickball_icon_srcs');
        var img_input_url = $(this).parent().parent().find('.radio-list').children().find('#qc_fab_custom_quickball_icon_inputs');

        $( img_destination ).attr('src', custom_image );
        $( img_input_url ).val( custom_image );
        
        
    });



    // floating_action_button Custom Quickball Icon
    $(document).on('click','.qc_fab_custom_quickballs_icon_button',function (e) {
        e.preventDefault();
        var img_destination = $(this).parent().parent().parent().find('.radio-list').children().find('#qc_fab_custom_quickball_icon_srcs');
        var img_input_url = $(this).parent().parent().parent().find('.radio-list').children().find('#qc_fab_custom_quickball_icon_inputs');
       // console.log(img_destination);

        var image = wp.media({
            title: 'Custom Icons',
            // mutiple: true if you want to upload multiple files at once
            multiple: false
        })
            .open()
            .on('select', function(e){
                // This will return the selected image from the Media Uploader, the result is an object
                var uploaded_image = image.state().get('selection').first();
                var image_url = uploaded_image.toJSON().url;
                // Let's assign the url value to the hidden field value and img src.
                $(img_destination).attr('src',image_url);
                $(img_input_url).val(image_url);
            });
    });





});



